QGIS Application - Bug report #19050

QGIS saves integer field when | create a new real field through field calculator (Update field works as
intended)

2018-05-28 10:46 PM - Stefan Newluck

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: Attribute table

Affected QGIS version:2.18.2 Regression?: Yes

Operating System: Windows 10 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupitsdata: Copied to github as #: 26880
Description

Problem:

When | create a new real field from within field calculator and calculate a decimal value, it is displayed correctly until | hit save. After save
the field is saved as integer.

Please see the attached screenshot for an illustration.

What should happen:

The field should of course stay real.

Workaround:

Hit "Create field" and create a real field there. Then open field calculator and calculate decimal values into that field by updating it. Hit
save and the field stays real.

Steps to reproduce:

0. Download this open data shapefile that | just use to confirm this bug:
http://data.statistik.gv.at/data/OGDEXT_POLBEZ_1_STATISTIK_AUSTRIA 20180101.zip
1. Open the shapefile's attribute table and start editing

2. Create a dummy integer field

3. Open field calculator and calculate a new field with the ratio of the two integer fields

4. Save the table

5. The real field turns into integer.

Associated revisions

Revision 033071ae - 2018-06-01 06:07 PM - Alessandro Pasotti

Do not set min/max precision for int fields

Fixes #19050

QGIS saves integer field when | create a new real
field through field calculator (Update field works as intended)

backport required

Revision a7bc5365 - 2018-06-04 08:43 AM - Alessandro Pasotti
http://data.statistik.gv.at/data/OGDEXT_POLBEZ_1_STATISTIK_AUSTRIA_20180101.zip

Do not set min/max precision for int fields

Fixes #19050

QGIS saves integer field when | create a new real
field through field calculator (Update field works as intended)

cherry-picked from master commit 033071a

History

#1 - 2018-06-01 05:20 PM - Alessandro Pasotti
- Assignee set to Alessandro Pasotti

| reproduced the issue, it looks like this is due to the "Output field length" value which is set to 0 by default when adding the field from "Create field" while

the default is 10 when created from the calculator.

Can you please confirm my findings?

#2 - 2018-06-01 06:13 PM - Alessandro Pasotti

- Regression? changed from No to Yes

- Resolution set to fixed/implemented

- Pull Request or Patch supplied changed from No to Yes

- Status changed from Open to In Progress

Requires backport

https://github.com/qgis/QGIS/pull/7143

#3 - 2018-06-02 11:40 AM - Stefan Newluck

Alessandro Pasotti wrote:

| reproduced the issue, it looks like this is due to the "Output field length" value which is set to 0 by default when adding the field from "Create field"

while the default is 10 when created from the calculator.

Can you please confirm my findings?

Exactly this is the difference. If | set the "Output field length" to 0 in field calculator, decimal values are stored correctly upon save.

Thank you for looking into it! I'm looking forward to testing the fix. :)

#4 - 2018-06-02 10:54 PM - Anonymous
- Status changed from In Progress to Closed
- % Done changed from 0 to 100
https://github.com/qgis/QGIS/pull/7143

Applied in changeset commit:qgis|033071ae502ebafe80d85cc5c470c6abf501e925.

Files

QGIS_bug.PNG 14.7 KB 2018-05-28 Stefan Newluck

2025-05-18 3/3



